% Connect to PWR Sensor
pm1 = NET.addAssembly('C:\Users\Sebastian\Desktop\MC\mcl_pm64.dll')
obja=mcl_pm64.usb_pm
obja.Open_AnySensor

% Connect to Switch
switch1 = NET.addAssembly('C:\Users\Sebastian\Desktop\MC\mcl_RF_Switch_Controller64.dll')
objc = mcl_RF_Switch_Controller64.USB_RF_SwitchBox
objc.Connect

% Connect to Sig Gen
gen1 = NET.addAssembly('C:\Users\Sebastian\Desktop\MC\mcl_gen64.dll')
objb = mcl_gen64.usb_gen
objb.Connect

% Switch to Cal Bridge
% 0 = Straight Through, 3 = Through DUT
% objc.Set_SwitchesPort(0)


%% Sweep System


% Drive Level in dBm
Power = -30
% Start Frequency in MHz
Fstart = 700
%Step Size in MHz
StepSize = 2.5
%Step Count
Steps = 400

%% Acquire Calibration Values
% Switch to Through Connection
objc.Set_SwitchesPort(0)
% Enable RF
objb.SetPowerON
% Sweep
for C = 1:Steps
    
    % Calculate Frequency
    F = Fstart + (StepSize*(C-1));
    % Set Frequency and Power
    objb.SetFreqAndPower(F,Power,0)
    % Allow some settling time
    pause(0.25);
    % Read Power
    PWR=obja.ReadPower
    PWR=round(10*PWR)/10
    % Write result into Array
    A(:,C) = PWR
end
objb.SetPowerOFF

% Normalize
for Count=1:length(A)
  A(:,Count)=A(:,Count)-Power;
end
CalValues = A

power = A

% Make Frequency Scale
freq = linspace(Fstart,F,length(A))
% Plot
figure;
plot(freq,power)


%% Acquire Real Values
% Switch to Through Connection
objc.Set_SwitchesPort(3)
% Enable RF
objb.SetPowerON
% Sweep
for C = 1:Steps
    
    % Calculate Frequency
    F = Fstart + (StepSize*(C-1));
    % Set Frequency and Power
    objb.SetFreqAndPower(F,Power,0)
    % Allow some settling time
    pause(0.25);
    % Read Power
    PWR=obja.ReadPower
    PWR=round(10*PWR)/10
    % Write result into Array
    Real(:,C) = PWR
end
objb.SetPowerOFF

% Normalize
for Count=1:length(Real)
  Real(:,Count)=Real(:,Count)-CalValues(:,Count)-Power;
end

power = Real

% Make Frequency Scale
freq = linspace(Fstart,F,length(Real))
% Plot
figure(2);
plot(freq,power)

%% END

% Disconenct all Devices
obja.Disconnect
objb.Disconnect
objc.Disconnect